/*
Copyright 2021 The KodeRover Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package executor

import (
	"fmt"

	"github.com/koderover/zadig/pkg/microservice/predator/core/service"
)

func Run() error {
	pred, err := service.NewPredator()
	if err != nil {
		fmt.Println("Failed to start predator, the error is:", err)
		return err
	}

	if err := pred.BeforeExec(); err != nil {
		fmt.Println("Failed to run before exec step, the error is:", err)
		return err
	}

	if err := pred.Exec(); err != nil {
		fmt.Println("Failed to run exec step, the error is:", err)
		return err
	}
	if err := pred.AfterExec(); err != nil {
		fmt.Println("Failed to run after exec step, the error is:", err)
		return err
	}

	return nil
}
